<?php
namespace Claromentis\Infocapture\Repository;

$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"] ?: array()) + array("_f0ce5625f7610e" . "b80be1df49fb91b" . "d80" => base64_decode("SU5TRVJUIElOVE8gaGRfZmllbGRzX2dyb3VwX2NvbnRlbnQoZ3JvdXBfaWQsI" . "GZpZWxkX3N5bV9uYW1lKQoJCQkJCQkJVkFMVUVTIChpbnQ6aWQsIHN0cjpuYW" . "1lKQ=="), "_eb0addf696578634c74648c345" . "dabaf0" => base64_decode("U0VMRUNUICogRlJPTSBoZF9maWVsZHN" . "fZ3JvdXAgV0hFUkUgaWQ9aW50Omlk"), "projec" . "t_id" => base64_decode("cHJvamVjdF" . "9pZA=="), "n" . "a" . "m" . "e" => base64_decode("bmF" . "tZQ" . "=="), "_b130615fe91ddb1db1cdfcbcaf34" . "4796" => base64_decode("REVMRVRFIEZST00gaGRfZmllbGRzX2dyb3VwX2Nvbn" . "RlbnQKCQkJCQkJV0hFUkUgZ3JvdXBfaWQ9aW50Omlk"), "_c2792bf964e36497f5" . "26072d3948bfbb" => base64_decode("VVBEQVRFIGhkX2ZpZWxkc19ncm91cAoJCQkJCQlTRVQgcHJvamVjdF9pZD1pbnQ6cGlkLCBuYW1lPX" . "N0cjpuYW1lCgkJCQkJCVdIRVJFIGlkPWludDppZA=="), "_eac43f36ccaefab544fb3a2bb" . "f02bf88" => base64_decode("SU5TRVJUIElOVE8gaGRfZmllbGRzX2dyb3VwKHByb2plY3RfaWQs" . "IG5hbWUpCgkJCQkJCVZBTFVFUyAoaW50OnBpZCwgc3RyOm5hbWUp"), "_6cd946a" . "fa118e34" . "ca19fc01" . "caacdda2" . "a" => base64_decode("REVMRVRFIEZST00gaGRfZ" . "mllbGRzX2dyb3VwIFdIRV" . "JFIGlkPWludDppZA=="), "_bf685946305bf3" . "10f666b87a68c31" . "f2d" => base64_decode("U0VMRUNUIGZpZWxkX3N5bV9uYW1lIEZST00gaGRfZmllbGRzX2dyb3VwX2NvbnRlbnQgV0hFUkUgZ3JvdXBfaWQ9aW50Omdp" . "ZA=="), "_e4c82166b4feb" . "2bb948c018fa56" . "39bd4" => base64_decode("REVMRVRFIEZST00gaGRfZmllbGRzX2dyb3VwX2NvbnRlbnQKCQkJCQlXSEVSRSBncm91cF9pZD1pbnQ6aW" . "Q="), "i" . "d" => base64_decode("aWQ" . "="));
use Claromentis\Core\DAL\Interfaces\DbInterface;
use Claromentis\Core\Event\EventDispatcher;
use Claromentis\Infocapture\Event\FieldGroupModifiedEvent;
use Claromentis\Infocapture\InfocaptureApplication;
use Claromentis\Infocapture\InfocaptureEvents;
use Claromentis\Infocapture\Model\ICFieldGroup;
class FieldGroupRepository
{
    
    
    protected $db;
    protected $dispatcher;
    
    
    protected $cache;
    public function __construct(DbInterface $db, EventDispatcher $_b497ce6f2af10f67516aed0ecf34d8cf)
    {
        $this->db = $db;
        $this->dispatcher = $_b497ce6f2af10f67516aed0ecf34d8cf;
    }
    
    
    
    
    public function Load(int $id) : ?ICFieldGroup
    {
        if ($id <= 0) {
            return null;
        }
        $_228a045965dce8051bc32fa56cedd325 = null;
        if (isset($this->cache[$id])) {
            $_228a045965dce8051bc32fa56cedd325 = clone $this->cache[$id];
            $_228a045965dce8051bc32fa56cedd325->fields = null;
        } else {
            $info = $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_eb0addf696578634c74648c345dab" . "af0"], $id)->fetchArray();
            if (isset($info)) {
                $_228a045965dce8051bc32fa56cedd325 = new ICFieldGroup();
                $_228a045965dce8051bc32fa56cedd325->setInfo($info);
                $this->cache[$id] = clone $_228a045965dce8051bc32fa56cedd325;
            }
        }
        return $_228a045965dce8051bc32fa56cedd325;
    }
    
    
    
    
    
    public function LoadWithFieldNames(int $id) : ?ICFieldGroup
    {
        if (isset($this->cache[$id])) {
            $_228a045965dce8051bc32fa56cedd325 = clone $this->cache[$id];
        } else {
            $_228a045965dce8051bc32fa56cedd325 = $this->Load($id);
        }
        if (!isset($_228a045965dce8051bc32fa56cedd325)) {
            return null;
        }
        if (!isset($_228a045965dce8051bc32fa56cedd325->fields)) {
            $fields = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_bf685946305bf310f666b87a68" . "c31f2d"], $id)->fetchAllValues();
            $_228a045965dce8051bc32fa56cedd325->fields = $fields;
            $this->cache[$id]->fields = $fields;
        }
        return $_228a045965dce8051bc32fa56cedd325;
    }
    
    
    
    
    
    public function Save(?ICFieldGroup ...$_3326d8e3c0b65a90b24f968cc4225c7d)
    {
        $this->db->DoTransaction(function (DbInterface $db) use($_3326d8e3c0b65a90b24f968cc4225c7d) {
            foreach ($_3326d8e3c0b65a90b24f968cc4225c7d as $_228a045965dce8051bc32fa56cedd325) {
                $this->SaveOne($_228a045965dce8051bc32fa56cedd325);
            }
        });
    }
    
    
    
    
    
    public function SaveOne(?ICFieldGroup $_228a045965dce8051bc32fa56cedd325)
    {
        if (!isset($_228a045965dce8051bc32fa56cedd325)) {
            return;
        }
        $this->db->DoTransaction(function (DbInterface $db) use($_228a045965dce8051bc32fa56cedd325) {
            if ($_228a045965dce8051bc32fa56cedd325->id) {
                $db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_c2792bf964e36497" . "f526072d3948bfbb"], $_228a045965dce8051bc32fa56cedd325->project_id, $_228a045965dce8051bc32fa56cedd325->name, $_228a045965dce8051bc32fa56cedd325->id);
            } else {
                $db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_eac43f36ccae" . "fab544fb3a2bb" . "f02bf88"], $_228a045965dce8051bc32fa56cedd325->project_id, $_228a045965dce8051bc32fa56cedd325->name);
                $_228a045965dce8051bc32fa56cedd325->setInfo([$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["i" . "d"] => $db->insertId(), $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["proj" . "ect_" . "id"] => $_228a045965dce8051bc32fa56cedd325->project_id, $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["nam" . "e"] => $_228a045965dce8051bc32fa56cedd325->name]);
            }
            if (isset($_228a045965dce8051bc32fa56cedd325->fields)) {
                $db->query($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_b130615fe91ddb1db1cdfcbcaf3" . "44796"], $_228a045965dce8051bc32fa56cedd325->id);
                foreach ($_228a045965dce8051bc32fa56cedd325->fields as $_66dc8b21e839a9a4739443a621ecc45a) {
                    $db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_f0ce5625" . "f7610eb80" . "be1df49fb" . "91bd80"], $_228a045965dce8051bc32fa56cedd325->id, $_66dc8b21e839a9a4739443a621ecc45a);
                }
            }
        });
        $event = new FieldGroupModifiedEvent($this->cache[$_228a045965dce8051bc32fa56cedd325->id] ?? null, $_228a045965dce8051bc32fa56cedd325);
        $this->dispatcher->dispatch(InfocaptureEvents::IC_FIELD_GROUP_MODIFIED, $event);
        $cache = clone $_228a045965dce8051bc32fa56cedd325;
        $_356c60c6f74ec31fe7a14d980e088ec1 = null;
        if (isset($this->cache[$cache->id])) {
            $_356c60c6f74ec31fe7a14d980e088ec1 = $this->cache[$cache->id]->fields;
        }
        $cache->fields = $cache->fields ?? $_356c60c6f74ec31fe7a14d980e088ec1;
        $this->cache[$cache->id] = $cache;
    }
    
    
    
    
    
    public function Delete(ICFieldGroup $_228a045965dce8051bc32fa56cedd325)
    {
        $_7e350312331e8d97526a308cebea7956 = $_228a045965dce8051bc32fa56cedd325->id;
        $this->db->DoTransaction(function (DbInterface $db) use($_228a045965dce8051bc32fa56cedd325) {
            $db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_6cd946afa118e34ca19fc0" . "1caacdda2a"], $_228a045965dce8051bc32fa56cedd325->id);
            $db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_e4c82166b4feb2bb948" . "c018fa5639bd4"], $_228a045965dce8051bc32fa56cedd325->id);
            $_228a045965dce8051bc32fa56cedd325->setInfo([$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["i" . "d"] => 0, $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["proj" . "ect_" . "id"] => $_228a045965dce8051bc32fa56cedd325->project_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["nam" . "e"] => $_228a045965dce8051bc32fa56cedd325->name]);
        });
        $event = new FieldGroupModifiedEvent($this->cache[$_7e350312331e8d97526a308cebea7956] ?? null, null);
        $this->dispatcher->dispatch(InfocaptureEvents::IC_FIELD_GROUP_MODIFIED, $event);
        unset($this->cache[$_7e350312331e8d97526a308cebea7956]);
    }
}